%global ver	7.8.50
%global snap	20140827

# Turn off the brp-python-bytecompile script
%global __os_install_post %(echo '%{__os_install_post}' | sed -e 's!/usr/lib[^[:space:]]*/brp-python-bytecompile[[:space:]].*$!!g')


#	Git snapshots are produced as follows:
#
#	git clone --recursive https://github.com/monnerat/insight.git
#	cd insight.git
#	autoconf
#	configure
#	make -C bundle -f src-release insight.tar.bz2
#
#	Tarball is then found at bundle/insight-%{ver}.%{snap}.tar.bz2

Name:		insight
Version:	%(echo %{ver} | tr - .)
Release:	6%{?snap:.%{snap}git}%{?dist}
Summary:	Graphical debugger based on GDB
License:	GPLv3+ and GPLv3+ with exceptions and GPLv2+ and GPLv2+ with exceptions and GPL+ and LGPLv2+ and BSD and Public Domain and GFDL
Group:		Development/Debuggers
Url:		https://www.sourceware.org/insight/
# Source0:	ftp://sourceware.org/pub/insight/releases/insight-%{ver}.tar.bz2
Source0:	insight-%{ver}%{?snap:.%{snap}}.tar.bz2
Source1:	insight.1
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires:	iwidgets
Requires:	xterm
Provides:	bundled(binutils) = 20140804
Provides:	bundled(gnulib) = 20140804
Provides:	bundled(libiberty) = 20140804
Provides:	bundled(md5-gcc) = 20140804
BuildRequires:	tcl-devel%{?_isa}
BuildRequires:	tk-devel%{?_isa}
BuildRequires:	iwidgets
BuildRequires:	ncurses-devel%{?_isa}
BuildRequires:	readline-devel%{?_isa} >= 6.0
BuildRequires:	expat-devel%{?_isa}
BuildRequires:	python-devel%{?_isa}
BuildRequires:	python2-devel
BuildRequires:	python3-devel
BuildRequires:	xz-devel%{?_isa}
BuildRequires:	zlib-devel%{?_isa}
BuildRequires:	ImageMagick%{?_isa}
BuildRequires:	desktop-file-utils%{?_isa}
BuildRequires:	autogen%{?_isa}
BuildRequires:	automake
BuildRequires:	autoconf
BuildRequires:	bison%{?_isa}
BuildRequires:	flex%{?_isa}
BuildRequires:	texinfo-tex
BuildRequires:	perl-podlators
BuildRequires:	libbabeltrace-devel
#	For C++ pretty printers.
BuildRequires:	libstdc++%{?_isa}

%if 0%{?fedora} <= 20
BuildRequires:	itcl-devel%{?_isa} < 4.0
BuildRequires:	itk-devel%{?_isa} < 4.0
%else
BuildRequires:	itcl-devel%{?_isa} >= 4.0
BuildRequires:	itk-devel%{?_isa} >= 4.0
%endif

#	Insight patches.

Patch1:		insight-7.4.50-relocate.patch
Patch2:		insight-7.4.50-readline-system.patch
Patch3:		insight-7.8.50-iwidgetsname.patch
Patch4:		insight-7.8.50-f20_backport.patch
Patch5:		insight-7.8.50-locvars.patch

#	Some patches from gdb. See gdb spec file for info.

Patch101:	gdb-archer.patch
Patch102:	insight-7.8.50-vla-intel.patch
Patch103:	gdb-vla-intel-04of23-fix.patch
Patch104:	gdb-vla-intel-stringbt-fix.patch
Patch105:	gdb-6.3-ppc64syscall-20040622.patch
Patch106:	gdb-6.3-ppc64displaysymbol-20041124.patch
Patch107:	insight-7.8.50-scheduler_locking-step-sw-watchpoints2.patch
Patch108:	gdb-6.3-gstack-20050411.patch
Patch109:	insight-7.8.50-readnever-20050907.patch
Patch110:	gdb-6.5-bz203661-emit-relocs.patch
Patch111:	gdb-6.5-bz185337-resolve-tls-without-debuginfo-v2.patch
Patch112:	gdb-6.5-bz190810-gdbserver-arch-advice.patch
Patch113:	gdb-6.5-bz216711-clone-is-outermost.patch
Patch114:	gdb-6.5-bz218379-solib-trampoline-lookup-lock-fix.patch
Patch115:	gdb-6.5-bz109921-DW_AT_decl_file-test.patch
Patch116:	insight-7.8.50-bz231832-obstack-2gb.patch
Patch117:	gdb-6.6-bz235197-fork-detach-info.patch
Patch118:	gdb-6.6-scheduler_locking-step-is-default.patch
Patch119:	gdb-6.6-buildid-locate.patch
Patch120:	gdb-6.6-buildid-locate-solib-missing-ids.patch
Patch121:	insight-7.8.50-buildid-locate-rpm.patch
Patch122:	gdb-6.8-sparc64-silence-memcpy-check.patch
Patch123:	gdb-6.8-bz436037-reg-no-longer-active.patch
Patch124:	gdb-x86_64-i386-syscall-restart.patch
Patch125:	gdb-bz533176-fortran-omp-step.patch
Patch126:	gdb-follow-child-stale-parent.patch
Patch127:	gdb-archer-pie-addons.patch
Patch128:	gdb-archer-pie-addons-keep-disabled.patch
Patch129:	insight-7.8.50-bz541866-rwatch-before-run.patch
Patch130:	gdb-moribund-utrace-workaround.patch
Patch131:	insight-7.8.50-buildid-locate-core-as-arg.patch
Patch132:	gdb-6.6-buildid-locate-rpm-librpm-workaround.patch
Patch133:	gdb-gdb-add-index-script.patch
Patch134:	gdb-bz568248-oom-is-error.patch
Patch135:	gdb-7.2.50-sparc-add-workaround-to-broken-debug-files.patch
Patch136:	gdb-glibc-vdso-workaround.patch
Patch137:	insight-7.8.50-attach-fail-reasons-5of5.patch
Patch138:	gdb-stale-frame_info.patch
Patch139:	gdb-glibc-strstr-workaround.patch
Patch140:	gdb-enable-count-crash.patch
Patch141:	gdb-gnat-dwarf-crash-3of3.patch
Patch142:	gdb-6.6-buildid-locate-misleading-warning-missing-debuginfo-rhbz981154.patch
Patch143:	gdb-btrobust.patch
Patch144:	insight-7.8.50-python-completer-1of2.patch
Patch145:	gdb-python-gil.patch
Patch146:	python-framefilter-invalidarg.patch
Patch147:	gdb-dts-rhel6-python-compat.patch
Patch148:	gdb-6.6-buildid-locate-rpm-scl.patch
Patch149:	gdb-readline62-ask-more-rh.patch
Patch150:	gdb-6.8-attach-signalled-detach-stopped.patch
Patch151:	gdb-6.8-quit-never-aborts.patch
Patch152:	gdb-rhel5-compat.patch

Patch200:	insight-7.8.50-vla-intel-2.patch


%description
 Insight is a tight graphical user interface to GDB written in Tcl/Tk.
It provides a comprehensive interface that enables users to harness
most of GDB's power. It's also probably the only up-to-date UI for
GDB version 6.x.


#-------------------------------------------------------------------------------
%prep 
#-------------------------------------------------------------------------------

%setup -q -n insight-%{ver}%{?snap:.%{snap}}

%patch1 -p1 -b .relocate
%patch2 -p1 -b .readline-system
%if 0%{?fedora} <= 20
%patch4 -p1 -b .f20_backport
%else
%patch3 -p1 -b .iwidgetsname
%endif
%patch5 -p1 -b .locvars

%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1

%patch105 -p1
%patch106 -p1
%patch107 -p1
%patch108 -p1
%patch109 -p1
%patch110 -p1
%patch111 -p1
%patch112 -p1
%patch113 -p1
%patch114 -p1
%patch115 -p1
%patch116 -p1
%patch117 -p1
%patch118 -p1
%patch119 -p1
%patch120 -p1
%patch121 -p1
%patch122 -p1
%patch123 -p1
%patch124 -p1
%patch125 -p1
%patch126 -p1
%patch127 -p1
%patch128 -p1
%patch129 -p1
%patch130 -p1
%patch131 -p1
%patch132 -p1
%patch133 -p1
%patch134 -p1
%patch135 -p1
%patch136 -p1
%patch137 -p1
%patch138 -p1
%patch139 -p1
%patch140 -p1
%patch141 -p1
%patch142 -p1
%patch143 -p1
%patch144 -p1
%patch145 -p1
%patch146 -p1

%patch147 -p1
%if 0%{!?el6:1}
%patch147 -p1 -R
%endif
%patch148 -p1
%if 0%{!?el6:1} || 0%{!?scl:1}
%patch148 -p1 -R
%endif
%patch149 -p1
%if 0%{?rhel:1} && 0%{?rhel} <= 6
%patch149 -p1 -R
%endif
%patch150 -p1
%patch151 -p1
%patch152 -p1
%if 0%{!?rhel:1} || 0%{?rhel} > 6
%patch152 -p1 -R
%patch151 -p1 -R
%patch150 -p1 -R
%endif

%patch200 -p1


#-------------------------------------------------------------------------------
%build
#-------------------------------------------------------------------------------

TOPDIR=`pwd`
rm -rf tcl tk itcl itk iwidgets readline

#	Need a complete reconfiguration after unbundling.

autogen Makefile.def
autoreconf

#	Patch requires some autotools rebuilds.

for location in gdb/gdbtk/plugins libgui
do	(
		cd $location
		aclocal -I "${TOPDIR}/config"
		automake
		autoconf
	)
done

#	Patch "readline-system" requires autoconf

(
	cd gdb
	aclocal -I "${TOPDIR}/config"
	autoconf
)

#	Get inclusion paths.

. "%{_libdir}/tclConfig.sh"
. "%{_libdir}/tkConfig.sh"

%configure	--enable-gdbtk						\
		--enable-sim						\
		--disable-rpath						\
		--with-gdb-datadir='%{_datadir}/insight'		\
		--with-jit-reader-dir='%{_libdir}/insight'		\
		--with-separate-debug-dir='/usr/lib/debug'		\
		--with-system-readline					\
		--with-expat						\
		--with-python						\
		--with-tclinclude="${TCL_SRC_DIR}"			\
		--with-tkinclude="${TK_SRC_DIR}"			\
		--without-libunwind					\
		--enable-64-bit-bfd					\
%if 0%{!?rhel:1}
		--with-babeltrace					\
%else
		--without-babeltrace					\
%endif
%if 0%{!?rhel:1} || 0%{?rhel} > 6
		--with-lzma						\
%else
		--without-lzma						\
%endif
		--with-auto-load-dir='$debugdir:$datadir/auto-load'	\
		--enable-targets=s390-linux-gnu,powerpc-linux-gnu,arm-linux-gnu,aarch64-linux-gnu \
		%{_target_platform}

make %{?_smp_mflags}


#-------------------------------------------------------------------------------
%install
#-------------------------------------------------------------------------------

rm -rf "${RPM_BUILD_ROOT}"

INSTALL="install -p"

make DESTDIR="${RPM_BUILD_ROOT}" INSTALL="${INSTALL}" install

#	Removes unnecessary stuff.

(
	cd	"${RPM_BUILD_ROOT}"

	rm -f .%{_bindir}/gcore
	rm -f .%{_bindir}/gdb-add-index
	rm -f .%{_bindir}/gdb
	rm -f .%{_bindir}/gdbtui
	rm -f .%{_bindir}/gdbserver
	rm -f .%{_bindir}/gstack

	rm -rf .%{_includedir}

	rm -f .%{_libdir}/*.a
	rm -f .%{_libdir}/*.la
	rm -f .%{_libdir}/*.sh
	rm -f .%{_libdir}/libinproctrace.so

	rm -rf .%{_prefix}/man
	rm -rf .%{_datadir}/man

	rm -rf .%{_datadir}/info
	rm -rf .%{_datadir}/locale
)

#	Regenerate the libgui pkgIndex.tcl file.

echo "pkg_mkIndex \"${RPM_BUILD_ROOT}%{_datadir}/insight/gui\"" | tclsh

#	Populate the auto-load directory from the libstdc++ gdb-specific
#		directory.

for i in $(echo bin lib $(basename '%{_libdir}') sbin | tr ' ' '\n' | sort -u)
do	mkdir -p "${RPM_BUILD_ROOT}%{_datadir}/insight/auto-load%{_prefix}/$i"
	ln -s "$(echo %{_prefix} | sed 's#^/*##')/$i"			\
	    "${RPM_BUILD_ROOT}%{_datadir}/insight/auto-load/$i"
	if [ -d "%{_datadir}/gdb/auto-load%{_prefix}/${i}" ]
	then	find "%{_datadir}/gdb/auto-load%{_prefix}/${i}" -mindepth 1
	fi
done | while read FROM
do	TO=`echo "${FROM}" | sed 's#/gdb/#/insight/#'`
	if [ -d "${FROM}" ]
	then	mkdir -p "${RPM_BUILD_ROOT}${TO}"
	else	ln -s "${FROM}" "${RPM_BUILD_ROOT}${TO}"
	fi
done

#	Install man file.

${INSTALL} -m 755 -d "${RPM_BUILD_ROOT}%{_mandir}/man1"
${INSTALL} -m 644 -p "%{SOURCE1}" "${RPM_BUILD_ROOT}%{_mandir}/man1/"

#	Create the menu entry.

${INSTALL} -m 755 -d "${RPM_BUILD_ROOT}%{_datadir}/applications"
desktop-file-install							\
	--dir		"${RPM_BUILD_ROOT}%{_datadir}/applications"	\
	gdb/gdbtk/insight.desktop

#	Install icon.

${INSTALL} -m 755 -d "${RPM_BUILD_ROOT}%{_datadir}/pixmaps"
convert -resize 256x256 "gdb/gdbtk/library/images/gdbtk_icon.gif"	\
	"${RPM_BUILD_ROOT}%{_datadir}/pixmaps/%{name}.png"

#	Python byte compile, but not in auto-load.

%py_byte_compile %{__python2} %{buildroot}%{_datadir}/insight/python
%py_byte_compile %{__python2} %{buildroot}%{_datadir}/insight/system-gdbinit


#-------------------------------------------------------------------------------
%clean 
#-------------------------------------------------------------------------------

rm -rf "${RPM_BUILD_ROOT}"


#-------------------------------------------------------------------------------
%files
#-------------------------------------------------------------------------------

%defattr(-, root, root, -)
%doc gdb/NEWS gdb/gdbtk/README gdb/gdbtk/plugins/HOW-TO COPYING COPYING3
%{_bindir}/*
%{_datadir}/insight
%{_datadir}/applications/*
%{_datadir}/pixmaps/*
%{_mandir}/man*/*


#-------------------------------------------------------------------------------
%changelog
#-------------------------------------------------------------------------------

* Tue Jun 23 2015 Patrick Monnerat <pm@datasphere.ch> 7.8.50-6.20140827git
- Patch "vla-intel-2" to fix a subexpression operator precedence.

* Wed Jan 21 2015 Patrick Monnerat <pm@datasphere.ch> 7.8.50-4.20140827git
- Conditionally backport to F20.
  https://bugzilla.redhat.com/show_bug.cgi?id=1184080
- Patch "locvars" to populate local variables window.
  https://github.com/monnerat/insight/commit/a8b05335
- Fix libstdc++ pretty printers implementation (for console window only).

* Tue Jan 13 2015 Patrick Monnerat <pm@datasphere.ch> 7.8.50-3.20140827git
- URL change.
- Do not install /usr/bin/gcore: now provided by the gdb package.
  https://bugzilla.redhat.com/show_bug.cgi?id=1180627

* Mon Oct 27 2014 Patrick Monnerat <pm@datasphere.ch> 7.8.50-2.20140827git
- Enlarge icon by resizing.
  https://bugzilla.redhat.com/show_bug.cgi?id=1157545

* Wed Aug 27 2014 Patrick Monnerat <pm@datasphere.ch> 7.8.50-1.20140827git
- New snapshot.
- Patch "iwidgetsname" for package name case spelling.
- Limited pretty printers support (from console window).

* Sat Aug 16 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 7.4.50-16.20120403cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Tue Jun 10 2014 Patrick Monnerat <pm@datasphere.ch> 7.4.50-15.20120403cvs
- Patch "tcl86" for tcl/tk version 8.6 and itcl/itk/iwidgets 4.0 compatibility.
- Patch "bfdarm" to fix bfd compilation on arm.
- Requires xterm for Fedora 21.

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 7.4.50-14.20120403cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Wed May 28 2014 Dan Horák <dan[at]danny.cz> - 7.4.50-13.20120403cvs
- fix build on s390(x) with a patch from binutils
- fix FTBFS due GCC 4.9

* Wed May 21 2014 Jaroslav Škarvada <jskarvad@redhat.com> - 7.4.50-12.20120403cvs
- Rebuilt for https://fedoraproject.org/wiki/Changes/f21tcl86

* Mon Mar  3 2014 Patrick Monnerat <pm@datasphere.ch> 7.4.50-11.20120403cvs
- Use our own python and syscalls scripts rather than gdb's.
  https://bugzilla.redhat.com/show_bug.cgi?id=1067668

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 7.4.50-10.20120403cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Jul  3 2013 Patrick Monnerat <pm@datasphere.ch> 7.4.50-9.20120403cvs
- Patch "texinfo5" to adapt doc to texinfo version 5.

* Wed Jul  3 2013 Patrick Monnerat <pm@datasphere.ch> 7.4.50-8.20120403cvs
- Compress snapshot tar archive with xz.
  https://bugzilla.redhat.com/show_bug.cgi?id=980597

* Fri Feb 15 2013 Patrick Monnerat <pm@datasphere.ch> 7.4.50-7.20120403cvs
- Patch "nocygnus" to replace automake option "cygnus" by "foreign no-dist".

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 7.4.50-6.20120403cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Dec  5 2012 Patrick Monnerat <pm@datasphere.ch> 7.4.50-5.20120403cvs
- Patch "bz883591" to fix a segmentation fault.
  https://bugzilla.redhat.com/show_bug.cgi?id=883591

* Thu Nov 15 2012 Patrick Monnerat <pm@datasphere.ch> 7.4.50-4.20120403cvs
- Path "objalloc" to fix libiberty security bug CVE-2012-3509.
  https://bugzilla.redhat.com/show_bug.cgi?id=877014
- Enable Python to support STL extensions.
  https://bugzilla.redhat.com/show_bug.cgi?id=865554

* Fri Jul 20 2012 Patrick Monnerat <pm@datasphere.ch> 7.4.50-3.20120403cvs
- Patch "structsiginfo" to replace occurrences of "struct siginfo" by
  "siginfo_t".

* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 7.4.50-2.20120403cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Tue Apr  3 2012 Patrick Monnerat <pm@datasphere.ch> 7.4.50-1.20120403cvs
- New cvs snapshot.
- Patches imported or adapted from gdb package.
- Patch "sig2dead" to avoid a segfault while notifying a signal to a dead
  process.
  http://sourceware.org/ml/insight/2012-q2/msg00002.html
- Patch "sizesizet" to fix a type mismatch between print format descriptors and
  corresponding argument.
  http://sourceware.org/ml/insight/2012-q2/msg00003.html

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 6.8.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Wed Feb  9 2011 Patrick Monnerat <pm@datasphere.ch> 6.8.1-4
- Patch "unused" to suppress "variable set but not used" errors.
- Patch "gcc45" to fix gcc 4.5 errors on incompatible enums.
  https://bugzilla.redhat.com/show_bug.cgi?id=631116

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 6.8.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Jan 13 2010 Patrick Monnerat <pm@datasphere.ch> 6.8.1-2
- Patch "sbrk" to enable sbrk() prototype on F13.

* Wed Jan 13 2010 Patrick Monnerat <pm@datasphere.ch> 6.8.1-1
- New version.
- Patch "baseclassfield" to fix bug BZ 551126.
- Start a terminal for standard IO when invoked through desktop file.

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 6.8-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Jul 15 2009 Patrick Monnerat <pm@datasphere.ch> 6.8-8
- Fix bug #511501: combobox.tcl installed twice causes build failure.
- Patch "readline6" to use system readline version 6.

* Mon Mar  2 2009 Patrick Monnerat <pm@datasphere.ch> 6.8-7
- Removed libXft-devel build requirement.
- .desktop file categories fixed.

* Tue Feb 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 6.8-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Feb 18 2009 Patrick Monnerat <pm@datasphere.ch> 6.8-5
- Patch "gcc44" to make it compilable with gcc 4.4.
- Build converts image format using ImageMagick instead of gif2png.
- Add build requirement of libXft-devel as a temporary workaround for missing
  dependence of tk-devel on it.

* Mon Oct 13 2008 Patrick Monnerat <pm@datasphere.ch> 6.8-4
- X-Fedora application category removed.
- Force option -p of install.

* Thu Oct  9 2008 Patrick Monnerat <pm@datasphere.ch> 6.8-3
- Patch "lib64" to enable tcl/tk/itcl/itk searches also in */lib64.

* Wed Oct  8 2008 Patrick Monnerat <pm@datasphere.ch> 6.8-2
- Patch "tclm4" to define tcl/tk autoconf macros in gdbtk/plugins directory.
- Use system readline.
- Force expat use.

* Thu Aug 14 2008 Patrick Monnerat <pm@datasphere.ch> 6.8-1
- Initial package.
- Patch "warnings" to suppress compilation warnings, since these abort rpmbuild.
- Patch "destdir" to properly install files when DESTDIR is defined.
- Patch "derefbug" to fix an address/value confusion bug.
- Patch "gcc43" to satisfy extra checks of gcc compiler version 4.3.
- Patch "ia64bound" to fix an array index out-of-bound bug in IA64
  specific code.
- Patch "itcl33" to migrate all code to itcl/itk version 3.3.
- Patch "syspackages" to use system-installed packages tck, tk, itcl, itk and
  iwidgets.
- Patch "relocate" to move all datadir/subdir stuff into datadir/insight (incl.
  libgui, that ought to be an external package). Non-binary libdir/* is also
  moved.
